<?php
// $Id: uc_favorder.pages.inc,v 1.1.4.2 2010/12/22 23:58:32 jmfederico Exp $

/**
 * Menu page callback.
 *
 * @return
 *   Drupal render array with:
 *    - help: Message to present to the user indicating what happens on the page
 *    - items: Favorite order products
 *    - form: Form construct from uc_favorder_load_favorder()
 *
 * @see uc_favorder_load_favorder()
 */
function uc_favorder_show_favorite_order($uid = NULL) {
  $products = uc_favorder_get_products($uid);
  if($products !== FALSE) {
    if(!empty($products)) {
      $account = user_load($uid);
      // @todo Improve message
      $content['help'] = array(
        '#type' => 'markup',
        '#markup' => t('<p>Hello @user, this is you favorite Order</p>', array('@user' =>  $account->name)),
      );

      $i = 0;
      $item_count = 0;
      $total = 0;
      $content['items']['#theme'] = 'table';
      $content['items']['#header'] = array('qty', 'product', 'total');
      foreach ($products as $item) {
        module_invoke_all('uc_cart_item', 'view', $item);
        $display_item = module_invoke($item->module, 'uc_cart_display', $item);
        if (!empty($display_item)) {
          $content['items']['#rows'][$i] = array(
            $display_item['qty']['#default_value'],
            $display_item['title']['#markup'] . $display_item['description']['#markup'],
            theme('uc_price', array('price' => $display_item['#total'])),
          );
          $i++;
          $item_count += $item->qty;
          $total += $display_item['#total'];
        }
      }

      $content['items']['#rows']['total'] = array(
        array(
          'data' => '<strong>' . t('Subtotal:') . '</strong> ' . theme('uc_price', array('price' => $total)),
          'colspan' => '3',
        ),
      );

      // Build the item count text and cart links.
      $item_text = format_plural($item_count, '<span class="num-items">1</span> Item', '<span class="num-items">@count</span> Items');
      $content['items']['#rows']['item_count'] = array(
        array(
          'data' => $item_text,
          'colspan' => '3',
        ),
      );


      // Retrieve form to add products to the cart
      // Pass favorite order content to the form
      $content['form'] = drupal_get_form('uc_favorder_load_favorder', $uid);
    }
    // If no favorite order is stored, inform the user
    else{
      $content = t('Sorry, you have no favorite order at this time.<br />To create it add products to your shopping cart.');
    }
  }
  else {
    drupal_not_found();
  }
  return $content;
}